<template lang="pug">
  div.sigma.leaderboard.item.ui.segment.inverted.stacked.three.column.stackable.grid
      div.sigma.leaderboard.item.index.one.wide.column #[i(:class="icon + ' icon highlight'")] {{ index }}
      div.sigma.leaderboard.item.user.wrapper.six.wide.column
        div.ui.sigma.leaderboard.item.user.two.column.stackable.grid
          div.ui.sigma.leaderboard.item.user.avatar.two.wide.column
            img.ui.image.tiny.circular.inline(:src="avatar")
          div.sigma.leaderboard.item.user.name.eight.wide.column {{ name }}
      div.sigma.leaderboard.item.progress.seven.wide.column
        p
          | Level {{ level }}:
          | #[span(v-if="prestige() > 0" class="prestige highlight") #[span {{ prestige() }}] #[i(class="star icon")]]
          | #[span {{ title }}]
        div.ui.active.progress.inverted
          div.bar(:style="'width: ' + nextPercentage + '%;'")
            div.progress {{ nextPercentage }}%
          div.label
            | #[span.highlight {{ this.numberWithCommas(value) }}] / {{ this.numberWithCommas(nextRequired) }}
</template>

<script lang="ts">
import { Vue, Component, Prop } from 'vue-property-decorator'
import 'semantic-ui-css/components/progress.min.css'

@Component
export default class SigmaLeaderboardItem extends Vue {
  @Prop(Number) readonly index!: number
  @Prop(String) readonly icon!: string
  @Prop(String) readonly name!: string
  @Prop(String) readonly avatar!: string
  @Prop(Number) readonly value!: number
  @Prop(Number) readonly level!: number
  @Prop(Number) readonly nextRequired!: number
  @Prop(Number) readonly nextPercentage!: number
  @Prop(Number) readonly tier!: number
  @Prop(String) readonly title!: string

  prestige () {
    return Math.floor(this.level / 100)
  }

  numberWithCommas (x: number) {
    let y = x.toString()
    var pattern = /(-?\d+)(\d{3})/
    while (pattern.test(y)) {
      y = y.replace(pattern, '$1,$2')
    }
    return y
  }
}
</script>

<style lang="stylus" scoped>
accent = #1abc9c
dark-accent = #1B6F5F

.sigma.leaderboard.item
  margin: unset
  & > .index
    font-size: 1.5rem
    margin-top: 2rem
  & > .name
    margin-top: 1rem
    font-size: 1.25rem
.ui.inverted.progress
  & > .bar
    background: dark-accent
.highlight
  color: accent
@media only screen and (max-device-width : 720px)
  .sigma.leaderboard.item
    text-align: center
</style>
